diff -crN nakedmudv1.5/src/object.h nakedmudv2.0/src/object.h
*** nakedmudv1.5/src/object.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/object.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 43,63 ****
  const char  *objGetMultiRdesc(OBJ_DATA *obj);
  EDESC_SET   *objGetEdescs    (OBJ_DATA *obj);
  const char  *objGetEdesc     (OBJ_DATA *obj, const char *keyword);
! char       **objGetDescPtr   (OBJ_DATA *obj);
  CHAR_DATA   *objGetCarrier   (OBJ_DATA *obj);
  CHAR_DATA   *objGetWearer    (OBJ_DATA *obj);
  OBJ_DATA    *objGetContainer (OBJ_DATA *obj);
  ROOM_DATA   *objGetRoom      (OBJ_DATA *obj);
  LIST        *objGetContents  (OBJ_DATA *obj);
  LIST        *objGetUsers     (OBJ_DATA *obj);
- int          objGetType      (OBJ_DATA *obj);
- int          objGetSubtype   (OBJ_DATA *obj);
  int          objGetUID       (OBJ_DATA *obj);
- int          objGetVal       (OBJ_DATA *obj, int num);
  double       objGetWeight    (OBJ_DATA *obj);
  double       objGetWeightRaw (OBJ_DATA *obj);
- double       objGetCapacity  (OBJ_DATA *obj);
  void        *objGetAuxiliaryData(const OBJ_DATA *obj, const char *name);
  
  void         objSetVnum      (OBJ_DATA *obj, obj_vnum vnum);
  void         objSetName      (OBJ_DATA *obj, const char *name);
--- 43,60 ----
  const char  *objGetMultiRdesc(OBJ_DATA *obj);
  EDESC_SET   *objGetEdescs    (OBJ_DATA *obj);
  const char  *objGetEdesc     (OBJ_DATA *obj, const char *keyword);
! BUFFER      *objGetDescBuffer(OBJ_DATA *obj);
  CHAR_DATA   *objGetCarrier   (OBJ_DATA *obj);
  CHAR_DATA   *objGetWearer    (OBJ_DATA *obj);
  OBJ_DATA    *objGetContainer (OBJ_DATA *obj);
  ROOM_DATA   *objGetRoom      (OBJ_DATA *obj);
  LIST        *objGetContents  (OBJ_DATA *obj);
  LIST        *objGetUsers     (OBJ_DATA *obj);
  int          objGetUID       (OBJ_DATA *obj);
  double       objGetWeight    (OBJ_DATA *obj);
  double       objGetWeightRaw (OBJ_DATA *obj);
  void        *objGetAuxiliaryData(const OBJ_DATA *obj, const char *name);
+ BITVECTOR   *objGetBits      (OBJ_DATA *obj);
  
  void         objSetVnum      (OBJ_DATA *obj, obj_vnum vnum);
  void         objSetName      (OBJ_DATA *obj, const char *name);
***************
*** 71,103 ****
  void         objSetWearer    (OBJ_DATA *obj, CHAR_DATA *ch);
  void         objSetContainer (OBJ_DATA *obj, OBJ_DATA  *cont);
  void         objSetRoom      (OBJ_DATA *obj, ROOM_DATA *room);
- void         objSetType      (OBJ_DATA *obj, int type);
- void         objSetSubtype   (OBJ_DATA *obj, int subtype);
- void         objSetVal       (OBJ_DATA *obj, int num, int val);
  void         objSetWeightRaw (OBJ_DATA *obj, double weight);
- void         objSetCapacity  (OBJ_DATA *obj, double capacity);
- 
- void         objToggleBit     (OBJ_DATA *obj, int field, int bit);
- void         objSetBit        (OBJ_DATA *obj, int field, int bit);
- void         objRemoveBit     (OBJ_DATA *obj, int field, int bit);
- bool         objIsBitSet      (OBJ_DATA *obj, int field, int bit);
- void         objPrintBits     (OBJ_DATA *obj, int field, char *buf);
- const char  *objBitGetName    (int field, int bit);
- 
- 
- //*****************************************************************************
- //
- // Bitfields and their bits
- //
- //*****************************************************************************
- #define BITFIELD_OBJ              0
- #define OBJ_NOTAKE                0  // (1 << 0)
- #define NUM_OBJ_BITS              1
- 
- #define BITFIELD_WEAP             1
- #define NUM_WEAP_BITS             0
- 
- #define BITFIELD_WORN             2
- #define NUM_WORN_BITS             0
  
  #endif // __OBJECT_H
--- 68,73 ----
diff -crN nakedmudv1.5/src/olc2/dedit.c nakedmudv2.0/src/olc2/dedit.c
*** nakedmudv1.5/src/olc2/dedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/dedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,201 ----
+ //*****************************************************************************
+ //
+ // dedit.c
+ //
+ // Dialogs are sets of reactions to speech that NPCs can have tagged onto them.
+ // This is these are the utilities for editing dialogs in OLC.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../dialog.h"
+ #include "../world.h"
+ #include "../zone.h"
+ #include "../socket.h"
+ #include "../character.h"
+ 
+ #include "../editor/editor.h"
+ 
+ #include "olc.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // olc for response data
+ //*****************************************************************************
+ #define RESPEDIT_KEYWORDS 1
+ 
+ void respedit_menu(SOCKET_DATA *sock, RESPONSE_DATA *response) {
+   send_to_socket(sock,
+ 		 "{g1) Keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Message\r\n"
+ 		 "{c%s\r\n",
+ 		 responseGetKeywords(response), 
+ 		 responseGetMessage(response)
+ 		 );
+ }
+ 
+ int respedit_chooser(SOCKET_DATA *sock, RESPONSE_DATA *response, char option) {
+   switch(toupper(option)) {
+   case '1':
+     text_to_buffer(sock, "Enter a new list of keywords: ");
+     return RESPEDIT_KEYWORDS;
+   case '2':
+     socketStartEditor(sock, dialog_editor, responseGetMessageBuffer(response));
+     return MENU_NOCHOICE;
+   default: return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool respedit_parser(SOCKET_DATA *sock, RESPONSE_DATA *response, int choice, 
+ 		     const char *arg) {
+   switch(choice) {
+   case RESPEDIT_KEYWORDS:
+     responseSetKeywords(response, arg);
+     return TRUE;
+   default: return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // olc for dialog data
+ //*****************************************************************************
+ #define DEDIT_TITLE      1
+ #define DEDIT_EDIT       2
+ #define DEDIT_DELETE     3
+ 
+ void dedit_menu(SOCKET_DATA *sock, DIALOG_DATA *dialog) {
+   int i, entries = dialogGetSize(dialog);
+   int half_entries = entries/2 + (entries % 2 == 1);
+   // entries are printed side by side... these are used to hold 'em
+   char left_buf[SMALL_BUFFER];
+   char right_buf[SMALL_BUFFER];
+ 
+   send_to_socket(sock,
+ 		 "{gT) Dialog title\r\n"
+ 		 "{c%s\r\n"
+ 		 "{gG) Greet/Approach message\r\n"
+ 		 "{c%s\r\n"
+ 		 "\r\n"
+ 		 "{gResponse Entries: {c%d\r\n", 
+ 		 dialogGetName(dialog), 
+ 		 (*dialogGetGreet(dialog) ? dialogGetGreet(dialog) : "<NONE>"), 
+ 		 entries);
+ 
+   // print out responses, two to a line
+   for(i = 0; i < half_entries; i++) {
+     RESPONSE_DATA *left_entry = dialogGetNum(dialog, i);
+     sprintf(left_buf, "  {g%2d) {c%s", i, responseGetKeywords(left_entry));
+     if(i + half_entries >= entries)
+       *right_buf = '\0';
+     else {
+       RESPONSE_DATA *right_entry = dialogGetNum(dialog, i + half_entries);
+       sprintf(right_buf, "  {g%2d) {c%s", 
+ 	      i + half_entries, responseGetKeywords(right_entry));
+     }
+     send_to_socket(sock, "%-35s %s\r\n", left_buf, right_buf);
+   }
+ 
+   send_to_socket(sock, "\r\n"
+ 		 "  {gE) edit entry\r\n"
+ 		 "  {gN) new entry\r\n"
+ 		 "  {gD) delete entry\r\n");
+ }
+ 
+ 
+ int dedit_chooser(SOCKET_DATA *sock, DIALOG_DATA *dialog, char option) {
+   switch(toupper(option)) {
+   case 'T':
+     text_to_buffer(sock, "Enter a new title for the dialog: ");
+     return DEDIT_TITLE;
+   case 'G':
+     socketStartEditor(sock, dialog_editor, dialogGetGreetBuffer(dialog));
+     return MENU_NOCHOICE;
+   case 'E':
+     text_to_buffer(sock, "Which response would you like to edit: ");
+     return DEDIT_EDIT;
+   case 'N': {
+     RESPONSE_DATA *response = newResponse();
+     dialogPut(dialog, response);
+     do_olc(sock, respedit_menu, respedit_chooser, respedit_parser, NULL, NULL,
+ 	   NULL, NULL, response);
+     return MENU_NOCHOICE;
+   case 'D':
+     text_to_buffer(sock, "Which response would you like to delete: ");
+     return DEDIT_DELETE;
+   default: return MENU_CHOICE_INVALID;
+   }
+   }
+ }
+ 
+ 
+ bool dedit_parser(SOCKET_DATA *sock, DIALOG_DATA *dialog, int choice, 
+ 		  const char *arg) {
+   switch(choice) {
+   case DEDIT_TITLE:
+     dialogSetName(dialog, arg);
+     return TRUE;
+ 
+   case DEDIT_EDIT: {
+     if(!isdigit(*arg))
+       return FALSE;
+     RESPONSE_DATA *response = dialogGetNum(dialog, atoi(arg));
+     if(response) {
+       do_olc(sock, respedit_menu, respedit_chooser, respedit_parser, NULL, NULL,
+ 	     NULL, NULL, response);
+     }
+     return TRUE;
+   }
+ 
+   case DEDIT_DELETE: {
+     if(!isdigit(*arg))
+       return FALSE;
+     RESPONSE_DATA *response = dialogGetNum(dialog, atoi(arg));
+     if(response) {
+       dialogRemove(dialog, response);
+       deleteResponse(response);
+     }
+     return TRUE;
+   }
+ 
+   default: return FALSE;
+   }
+ }
+ 
+ COMMAND(cmd_dedit) {
+   ZONE_DATA *zone;
+   DIALOG_DATA *dialog;
+   int vnum;
+ 
+   // we need to know which dialog...
+   if(!arg || !*arg || !isdigit(*arg))
+     send_to_char(ch, "Which dialog did you want to edit?\r\n");
+   else {
+     vnum = atoi(arg);
+ 
+     // make sure there is a corresponding zone ...
+     if((zone = worldZoneBounding(gameworld, vnum)) == NULL)
+       send_to_char(ch, "No zone exists that contains the given vnum.\r\n");
+     else if(!canEditZone(zone, ch))
+       send_to_char(ch, "You are not authorized to edit this zone.\r\n");  
+     else {
+       // find the dialog
+       dialog = zoneGetDialog(zone, vnum);
+ 
+       // make our dialog
+       if(dialog == NULL) {
+ 	dialog = newDialog();
+ 	dialogSetVnum (dialog, vnum);
+ 	dialogSetName (dialog, "An Unfinished Dialog");
+ 	dialogSetGreet(dialog, "Hi! This dialog is unfinished.");
+ 	zoneAddDialog(zone, dialog);
+       }
+       
+       do_olc(charGetSocket(ch), dedit_menu, dedit_chooser, dedit_parser,
+ 	     dialogCopy, dialogCopyTo, deleteDialog, save_world, dialog);
+     }
+   }
+ }
diff -crN nakedmudv1.5/src/olc2/dedit.d nakedmudv2.0/src/olc2/dedit.d
*** nakedmudv1.5/src/olc2/dedit.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/dedit.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ olc2/dedit.d olc2/dedit.o: olc2/dedit.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h dialog.h world.h zone.h socket.h \
+   character.h editor/editor.h olc2/olc.h
diff -crN nakedmudv1.5/src/olc2/esedit.c nakedmudv2.0/src/olc2/esedit.c
*** nakedmudv1.5/src/olc2/esedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/esedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,128 ----
+ //*****************************************************************************
+ //
+ // esedit.c
+ //
+ // Contains all of the functions for doing the olc editing of extra description
+ // sets. Used by rooms, objects (and mobiles?)
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../socket.h"
+ #include "../extra_descs.h"
+ #include "../editor/editor.h"
+ 
+ #include "olc.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // functions for editing a single extra description
+ //*****************************************************************************
+ #define EDEDIT_KEYWORD     1
+ 
+ void edesc_menu(SOCKET_DATA *sock, EDESC_DATA *edesc) {
+   send_to_socket(sock,
+ 		 "{g1) Keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Description\r\n"
+ 		 "{c%s\r\n",
+ 		 edescSetGetKeywords(edesc), 
+ 		 edescSetGetDesc(edesc)
+ 		 );
+ }
+ 
+ int  edesc_chooser(SOCKET_DATA *sock, EDESC_DATA *edesc, char option) {
+   switch(toupper(option)) {
+   case '1':
+     text_to_buffer(sock, "Enter a new list of keywords: ");
+     return EDEDIT_KEYWORD;
+   case '2':
+     socketStartEditor(sock, text_editor, edescGetDescBuffer(edesc));
+     return MENU_NOCHOICE;
+   default:
+     return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool edesc_parser(SOCKET_DATA *sock, EDESC_DATA *edesc, int choice, 
+ 		  const char *arg) {
+   switch(choice) {
+   case EDEDIT_KEYWORD:
+     edescSetKeywords(edesc, arg);
+     return TRUE;
+   default:
+     return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // functions for editing an extra description set
+ //*****************************************************************************
+ #define ESEDIT_DELETE     1
+ #define ESEDIT_EDIT       2
+ 
+ void edesc_set_menu(SOCKET_DATA *sock, EDESC_SET *set) {
+   int i, entries = edescGetSetSize(set);
+ 
+   send_to_socket(sock,
+ 		 "{gEntries: {c%d\r\n", entries);
+   // print out each one
+   for(i = 0; i < entries; i++)
+     send_to_socket(sock, "  {g%2d) {c%s\r\n", i, 
+ 		   edescSetGetKeywords(edescSetGetNum(set, i)));
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "{gE) edit entry\r\n"
+ 		 "{gN) new entry\r\n"
+ 		 "{gD) delete entry\r\n"
+ 		 );
+ }
+ 
+ int  edesc_set_chooser(SOCKET_DATA *sock, EDESC_SET *set, char option) {
+   switch(toupper(option)) {
+   case 'E':
+     text_to_buffer(sock, "Enter the number of the edesc to edit: ");
+     return ESEDIT_EDIT;
+   case 'N': {
+     // create a new edesc
+     EDESC_DATA *edesc = newEdesc("", "");
+     edescSetPut(set, edesc);
+     do_olc(sock, edesc_menu, edesc_chooser, edesc_parser, NULL, NULL, NULL,
+ 	   NULL, edesc);
+     return MENU_NOCHOICE;
+   }
+   case 'D':
+     text_to_buffer(sock, "Enter the number of the edesc to delete: ");
+     return ESEDIT_DELETE;
+   default:
+     return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ 
+ bool edesc_set_parser(SOCKET_DATA *sock, EDESC_SET *set, int choice,
+ 		       const char *arg) {
+   switch(choice) {
+   case ESEDIT_EDIT: {
+     EDESC_DATA *edesc = edescSetGetNum(set, atoi(arg));
+     if(edesc == NULL)
+       return FALSE;
+     do_olc(sock, edesc_menu, edesc_chooser, edesc_parser, NULL, NULL, NULL,
+ 	   NULL, edesc);
+     return TRUE;
+   }
+   case ESEDIT_DELETE: {
+     EDESC_DATA *edesc = edescSetGetNum(set, atoi(arg));
+     if(edesc) {
+       removeEdesc(set, edesc);
+       deleteEdesc(edesc);
+     }
+     return TRUE;
+   }
+   default:
+     return FALSE;
+   }
+ }
diff -crN nakedmudv1.5/src/olc2/esedit.d nakedmudv2.0/src/olc2/esedit.d
*** nakedmudv1.5/src/olc2/esedit.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/esedit.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ olc2/esedit.d olc2/esedit.o: olc2/esedit.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h socket.h extra_descs.h \
+   editor/editor.h olc2/olc.h
diff -crN nakedmudv1.5/src/olc2/medit.c nakedmudv2.0/src/olc2/medit.c
*** nakedmudv1.5/src/olc2/medit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/medit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,194 ----
+ //*****************************************************************************
+ //
+ // medit.c
+ //
+ // The functions needed for doing online editing of mobiles.
+ //
+ //*****************************************************************************
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../socket.h"
+ #include "../character.h"
+ #include "../races.h"
+ #include "../world.h"
+ #include "../dialog.h"
+ #include "../zone.h"
+ 
+ #include "olc.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // mandatory modules
+ //*****************************************************************************
+ #include "../scripts/script.h"
+ #include "../editor/editor.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // mobile editing
+ //*****************************************************************************
+ #define MEDIT_NAME          1
+ #define MEDIT_MULTI_NAME    2
+ #define MEDIT_KEYWORDS      3
+ #define MEDIT_RDESC         4
+ #define MEDIT_MULTI_RDESC   5
+ #define MEDIT_RACE          6
+ #define MEDIT_SEX           7
+ #define MEDIT_DIALOG        8
+ 
+ void medit_menu(SOCKET_DATA *sock, CHAR_DATA *mob) {
+   send_to_socket(sock,
+ 		 "{g[{c%d{g]\r\n"
+ 		 "{g1) Name\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Name for multiple occurences\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g3) Keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g4) Room description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g5) Room description for multiple occurences\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g6) Description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{gS) Script menu\r\n"
+ 		 "{gR) Change race   {y[{c%8s{y]\r\n"
+ 		 "{gG) Change Gender {y[{c%8s{y]\r\n"
+ 		 "{gD) Dialog        {y[{c%8d{y]  {w%s\r\n",
+ 		 charGetVnum(mob),
+ 		 charGetName(mob),
+ 		 charGetMultiName(mob),
+ 		 charGetKeywords(mob),
+ 		 charGetRdesc(mob),
+ 		 charGetMultiRdesc(mob),
+ 		 charGetDesc(mob),
+ 		 charGetRace(mob),
+ 		 sexGetName(charGetSex(mob)),
+ 		 charGetDialog(mob),
+ 		 (worldGetDialog(gameworld, charGetDialog(mob)) ?
+ 		  dialogGetName(worldGetDialog(gameworld, 
+ 					       charGetDialog(mob))) : "")
+ 		 );
+ }
+ 
+ int  medit_chooser(SOCKET_DATA *sock, CHAR_DATA *mob, char option) {
+   switch(toupper(option)) {
+   case '1':
+     text_to_buffer(sock, "Enter name: ");
+     return MEDIT_NAME;
+   case '2':
+     text_to_buffer(sock, "Enter name for multiple occurences: ");
+     return MEDIT_MULTI_NAME;
+   case '3':
+     text_to_buffer(sock, "Enter keywords: ");
+     return MEDIT_KEYWORDS;
+   case '4':
+     text_to_buffer(sock, "Enter room description: ");
+     return MEDIT_RDESC;
+   case '5':
+     text_to_buffer(sock, "Enter room description for multiple occurences: ");
+     return MEDIT_MULTI_RDESC;
+   case '6':
+     text_to_buffer(sock, "Enter description\r\n");
+     socketStartEditor(sock, text_editor, charGetDescBuffer(mob));
+     return MENU_NOCHOICE;
+   case 'R':
+     send_to_socket(sock, "%s\r\n\r\n", raceGetList(FALSE));
+     send_to_socket(sock, "Please select a race: ");
+     return MEDIT_RACE;
+   case 'G':
+     olc_display_table(sock, sexGetName, NUM_SEXES, 1);
+     return MEDIT_SEX;
+   case 'D':
+     text_to_buffer(sock, "Enter the dialog vnum (-1 for none): ");
+     return MEDIT_DIALOG;
+   case 'S':
+     do_olc(sock, ssedit_menu, ssedit_chooser, ssedit_parser,
+ 	   NULL, NULL, NULL, NULL, charGetScripts(mob));
+     return MENU_NOCHOICE;
+   default: return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool medit_parser(SOCKET_DATA *sock, CHAR_DATA *mob, int choice, 
+ 		  const char *arg) {
+   switch(choice) {
+   case MEDIT_NAME:
+     charSetName(mob, arg);
+     return TRUE;
+   case MEDIT_MULTI_NAME:
+     charSetMultiName(mob, arg);
+     return TRUE;
+   case MEDIT_KEYWORDS:
+     charSetKeywords(mob, arg);
+     return TRUE;
+   case MEDIT_RDESC:
+     charSetRdesc(mob, arg);
+     return TRUE;
+   case MEDIT_MULTI_RDESC:
+     charSetMultiRdesc(mob, arg);
+     return TRUE;
+   case MEDIT_RACE:
+     if(!isRace(arg))
+       return FALSE;
+     charSetRace(mob, arg);
+     return TRUE;
+   case MEDIT_SEX: {
+     int val = atoi(arg);
+     if(!isdigit(*arg) || val < 0 || val >= NUM_SEXES)
+       return FALSE;
+     charSetSex(mob, val);
+     return TRUE;
+   }
+   case MEDIT_DIALOG: {
+     int vnum = (isdigit(*arg) ? atoi(arg) : NOTHING);
+     DIALOG_DATA *dialog = worldGetDialog(gameworld, vnum);
+     if(!dialog && vnum != NOTHING)
+       return FALSE;
+     else {
+       charSetDialog(mob, vnum);    
+       return TRUE;
+     }
+   }
+   default: return FALSE;
+   }
+ }
+ 
+ COMMAND(cmd_medit) {
+   ZONE_DATA *zone;
+   CHAR_DATA *mob;
+   mob_vnum vnum;
+ 
+   if(!arg || !*arg || !isdigit(*arg))
+     send_to_char(ch, "Invalid vnum! Try again.\r\n");
+   else {
+     vnum = atoi(arg);
+ 
+     // make sure there is a corresponding zone ...
+     if((zone = worldZoneBounding(gameworld, vnum)) == NULL)
+       send_to_char(ch, "No zone exists that contains the given vnum.\r\n");
+     else if(!canEditZone(zone, ch))
+       send_to_char(ch, "You are not authorized to edit this zone.\r\n");  
+     else {
+       // find the mobile
+       mob = zoneGetMob(zone, vnum);
+ 
+       // make our mobile
+       if(mob == NULL) {
+ 	mob = newMobile(vnum);
+ 	zoneAddMob(zone, mob);
+ 	charSetName(mob, "an unfinished mobile");
+ 	charSetKeywords(mob, "mobile, unfinshed");
+ 	charSetRdesc(mob, "an unfinished mobile is standing here.");
+ 	charSetDesc(mob, "it looks unfinished.\r\n");
+ 	charSetMultiName(mob, "%d unfinished mobiles");
+ 	charSetMultiRdesc(mob, "A group of %d mobiles are here, looking unfinished.");
+       }
+ 
+       do_olc(charGetSocket(ch), medit_menu, medit_chooser, medit_parser,
+ 	     charCopy, charCopyTo, deleteChar, save_world, mob);
+     }
+   }
+ }
diff -crN nakedmudv1.5/src/olc2/medit.d nakedmudv2.0/src/olc2/medit.d
*** nakedmudv1.5/src/olc2/medit.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/medit.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ olc2/medit.d olc2/medit.o: olc2/medit.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h socket.h character.h \
+   races.h world.h dialog.h zone.h olc2/olc.h scripts/script.h \
+   editor/editor.h
diff -crN nakedmudv1.5/src/olc2/module.mk nakedmudv2.0/src/olc2/module.mk
*** nakedmudv1.5/src/olc2/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/module.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ SRC  += olc2/olc.c olc2/redit.c olc2/zedit.c olc2/esedit.c olc2/dedit.c \
+ 	olc2/medit.c olc2/oedit.c
diff -crN nakedmudv1.5/src/olc2/oedit.c nakedmudv2.0/src/olc2/oedit.c
*** nakedmudv1.5/src/olc2/oedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/oedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,177 ----
+ //*****************************************************************************
+ //
+ // oedit.c
+ //
+ // The functions needed for doing online editing of objects
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../socket.h"
+ #include "../character.h"
+ #include "../object.h"
+ #include "../world.h"
+ #include "../zone.h"
+ 
+ #include "olc.h"
+ #include "olc_submenus.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // mandatory modules
+ //*****************************************************************************
+ #include "../scripts/script.h"
+ #include "../editor/editor.h"
+ #include "../items/iedit.h"
+ #include "../items/items.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // object editing
+ //*****************************************************************************
+ #define OEDIT_NAME          1
+ #define OEDIT_MULTI_NAME    2
+ #define OEDIT_KEYWORDS      3
+ #define OEDIT_RDESC         4
+ #define OEDIT_MULTI_RDESC   5
+ #define OEDIT_WEIGHT        6
+ 
+ void oedit_menu(SOCKET_DATA *sock, OBJ_DATA *obj) {
+   send_to_socket(sock,
+ 		 "{g[{c%d{g]\r\n"
+ 		 "{g1) Name\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Name for multiple occurences\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g3) Keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g4) Room description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g5) Room description for multiple occurences\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g6) Description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{gW) Weight:    {c%1.3lf\r\n"
+ 		 "{gT) Edit item types: {c%s\r\n"
+ 		 "{gS) Script menu\r\n"
+ 		 "{gX) Extra Descriptions menu\r\n",
+ 		 objGetVnum(obj),
+ 		 objGetName(obj),
+ 		 objGetMultiName(obj),
+ 		 objGetKeywords(obj),
+ 		 objGetRdesc(obj),
+ 		 objGetMultiRdesc(obj),
+ 		 objGetDesc(obj),
+ 		 objGetWeightRaw(obj),
+ 		 objGetTypes(obj)
+ 		 );
+ }
+ 
+ int  oedit_chooser(SOCKET_DATA *sock, OBJ_DATA *obj, char option) {
+   switch(toupper(option)) {
+   case '1':
+     text_to_buffer(sock, "Enter name: ");
+     return OEDIT_NAME;
+   case '2':
+     text_to_buffer(sock, "Enter name for multiple occurences: ");
+     return OEDIT_MULTI_NAME;
+   case '3':
+     text_to_buffer(sock, "Enter keywords: ");
+     return OEDIT_KEYWORDS;
+   case '4':
+     text_to_buffer(sock, "Enter room description: ");
+     return OEDIT_RDESC;
+   case '5':
+     text_to_buffer(sock, "Enter room description for multiple occurences: ");
+     return OEDIT_MULTI_RDESC;
+   case '6':
+     text_to_buffer(sock, "Enter description\r\n");
+     socketStartEditor(sock, text_editor, objGetDescBuffer(obj));
+     return MENU_NOCHOICE;
+   case 'W':
+     text_to_buffer(sock, "Enter new weight: ");
+     return OEDIT_WEIGHT;
+   case 'X':
+     do_olc(sock, edesc_set_menu, edesc_set_chooser, edesc_set_parser, NULL,NULL,
+ 	   NULL, NULL, objGetEdescs(obj));
+     return MENU_NOCHOICE;
+   case 'T':
+     do_olc(sock, iedit_menu, iedit_chooser, iedit_parser, NULL, NULL, NULL,
+ 	   NULL, obj);
+     return MENU_NOCHOICE;
+   case 'S':
+     do_olc(sock, ssedit_menu, ssedit_chooser, ssedit_parser,
+ 	   NULL, NULL, NULL, NULL, objGetScripts(obj));
+     return MENU_NOCHOICE;
+   default: return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool oedit_parser(SOCKET_DATA *sock, OBJ_DATA *obj, int choice, 
+ 		  const char *arg){
+   switch(choice) {
+   case OEDIT_NAME:
+     objSetName(obj, arg);
+     return TRUE;
+   case OEDIT_MULTI_NAME:
+     objSetMultiName(obj, arg);
+     return TRUE;
+   case OEDIT_KEYWORDS:
+     objSetKeywords(obj, arg);
+     return TRUE;
+   case OEDIT_RDESC:
+     objSetRdesc(obj, arg);
+     return TRUE;
+   case OEDIT_MULTI_RDESC:
+     objSetMultiRdesc(obj, arg);
+     return TRUE;
+   case OEDIT_WEIGHT: {
+     double val = atof(arg);
+     if(val < 0) return FALSE;
+     objSetWeightRaw(obj, val);
+     return TRUE;
+   }
+   default: return FALSE;
+   }
+ }
+ 
+ COMMAND(cmd_oedit) {
+   ZONE_DATA *zone;
+   OBJ_DATA *obj;
+   obj_vnum vnum;
+ 
+   // if no argument is supplied, default to the current obj
+   if(!arg || !*arg)
+     send_to_char(ch, "Please supply the vnum of a obj you wish to edit.\r\n");
+   else {
+     vnum = atoi(arg);
+ 
+     // make sure there is a corresponding zone ...
+     if((zone = worldZoneBounding(gameworld, vnum)) == NULL)
+       send_to_char(ch, "No zone exists that contains the given vnum.\r\n");
+     else if(!canEditZone(zone, ch))
+       send_to_char(ch, "You are not authorized to edit this zone.\r\n");  
+     else {
+       // find the obj
+       obj = worldGetObj(gameworld, vnum);
+ 
+       // make our obj
+       if(obj == NULL) {
+ 	obj = newObj(vnum);
+ 	objSetVnum(obj, vnum);
+ 	objSetName      (obj, "an unfinished object");
+ 	objSetKeywords  (obj, "object, unfinshed");
+ 	objSetRdesc     (obj, "an unfinished object is lying here.");
+ 	objSetDesc      (obj, "it looks unfinished.\r\n");
+ 	objSetMultiName (obj, "a group of %d unfinished objects");
+ 	objSetMultiRdesc(obj, "%d objects lay here, all unfinished.");
+       }
+ 
+       do_olc(charGetSocket(ch), oedit_menu, oedit_chooser, oedit_parser,
+ 	     objCopy, objCopyTo, deleteObj, save_world, obj);
+     }
+   }
+ }
diff -crN nakedmudv1.5/src/olc2/oedit.d nakedmudv2.0/src/olc2/oedit.d
*** nakedmudv1.5/src/olc2/oedit.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/olc2/oedit.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ olc2/oedit.d olc2/oedit.o: olc2/oedit.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h socket.h character.h \
+   object.h world.h zone.h olc2/olc.h olc2/olc_submenus.h scripts/script.h \
+   editor/editor.h items/iedit.h items/items.h
